unit hiMT_String;

interface

uses Kol,Share,Debug;

type
  THIMT_String = class(TDebug)
   private
    st: string;
   public
    _prop_Delimeter:string;
    _data_str1:THI_Event;
    _event_Result:THI_Event;

    procedure _work_doStr(var _Data:TData; Index:word);
    procedure _work_doMT(var _Data:TData; Index:word);
    procedure _var_Str(var _Data:TData; Index:word);
  end;

implementation
//#############     .    
//#############     :)   int,real( )  string
function StrToTData(s: string):TData;
var i: integer;
    t: byte;
    s1: string;
begin
  t:=data_Str; s1:=trim(s);
  for i:=1 to length(s1) do
     if (s1[i] in ['0'..'9','-','.']) or ((s[i]='-') and (i=1)) then begin
       if s1[i]='.' then t:=data_real else if t<>data_real then t:=data_int;
     end else
       begin t:=data_str; break; end;

  case t of
    data_str: result:=_doData(s);
    data_int: result:=_doData(str2int(s1));
    data_real: result:=_doData(str2double(s1));
  end;
//  result:=_doData(s);
end;

// ################## MT_String #######################

procedure THIMT_String._work_doStr;
var d: PData;
begin
  d := @_data;
  st:='';
  while d <> nil do
    begin
      st:=st+ToString(d^)+_prop_Delimeter;
      d := d.ldata;
    end;
  deleteTail(st,1);
  _hi_OnEvent(_event_Result,st);
end;

procedure THIMT_String._work_doMT;
var d: PData;
    dt: TData;
begin
  d:=@dt;
  st := ReadString(_Data,_data_Str1,'');
  while st <> '' do
    begin
      d^:=StrToTData(parse(st,_prop_Delimeter));
      if st<>'' then begin new(d.ldata); d:=d.ldata; end else d.ldata:=nil;
    end;
  _hi_OnEvent(_event_Result, dt);
  freedata(@dt);
end;

procedure THIMT_String._var_Str;
begin
  dtString(_Data,st);
end;

end.
